<?php

namespace Slovocast\Domain\Repository\Episode;

use Slovocast\Domain\Entity\Episode;
use Slovocast\Domain\Entity\Episode\File;

/**
 * The Episode File repository should consist of getting and setting the data
 * about the file stored in the database. The implementation of this class
 * should concern itself with the metadata _about_ the file, not the file
 * itself.
 */
interface EpisodeFileRepositoryInterface
{
    public function get(string $location): File;
    public function getFromEpisode(Episode $episode): File;
    public function create(File $file): File;
    public function update(File $file): bool;
    public function delete(File $file): bool;
}
