<?php

namespace Slovocast\Feed;

use DOMDocument;
use Slovocast\Domain\Entity\Channel;

interface FeedGeneratorInterface
{
    /**
     * XMLNS Definitions that should be updated as new namespaces get added.
     * This could probably be defined somewhere else if we need it. These are
     * pulled from some old Podbean feeds - so we should probably fine another
     * source for the definitive list
     */
    const XMLNS_CONTENT="http://purl.org/rss/1.0/modules/content/";
    const XMLNS_WFW="http://wellformedweb.org/CommentAPI";
    const XMLNS_DC="http://purl.org/dv/elements/1.1/";
    const XMLNS_ATOM="http://www.w3.org/2005/Atom";
    const XMLNS_ITUNES="http://www.itunes.com/dtds/podcast-1.0.dtd";
    const XMLNS_GOOGLEPLAY="http://www.google.com/schemas/play-podcasts/1.0";
    const XMLNS_SPOTIFY="https://www.spotify.com/ns/rss";
    const XMLNS_MEDAI="http://search.yahoo.com/mrss/";

    public function generate(Channel $channel): DOMDocument;
}
