<?php

namespace Slovocast\Handler;

use Psr\Http\Message\ResponseInterface;
use Slovocast\Exception\TemplateNotSetException;

abstract class Page extends Handler
{
    protected string $template = '';
    protected array $pageProps = [];

    /**
     * @throws TemplateNotSetException
     */
    public function handle(): ResponseInterface
    {
        if (!$this->template) {
            throw new TemplateNotSetException("No template set.");
        }

        return $this->render($this->template, $this->pageProps);
    }
}
