<?php

namespace Slovocast\Handler\User;

use Odan\Session\FlashInterface;
use Slovocast\Handler\Handler;
use Psr\Http\Message\ResponseInterface as Response;
use Odan\Session\SessionInterface;

class LogoutUserAction extends Handler
{
    public function __construct(
        protected SessionInterface $session,
    ) { }


    public function handle(): Response
    {
        if ($this->session->has('authenticated')) {
            $this->session->delete('authenticated');
        }

        if ($this->session->has('user')) {
            $this->session->delete('user');
        }

        $this->session->getFlash()->add("notice", "Successfully logged out.");
        return $this->redirect('/', 302);
    }
}
